#include <iostream>
#include <cstring>

class DynamicString {
private:
    char* data;

public:
    DynamicString(const char* str) {
        data = new char[strlen(str) + 1];
        strcpy(data, str);
    }

    // Copy constructor
    DynamicString(const DynamicString& other) {
        data = new char[strlen(other.data) + 1];
        strcpy(data, other.data);
        std::cout << "Deep copy constructor called" << std::endl;
    }

    // Destructor
    ~DynamicString() {
        delete[] data;
    }

    void display() const {
        std::cout << data << std::endl;
    }
};

int main() {
    DynamicString s1("Hello, World!");
    DynamicString s2 = s1;  // Copy constructor called

    std::cout << "String 1: ";
    s1.display();
    std::cout << "String 2: ";
    s2.display();

    return 0;
}
