#include <iostream>
#include <memory>

class Resource {
public:
    Resource() { std::cout << "Resource acquired" << std::endl; }
    ~Resource() { std::cout << "Resource released" << std::endl; }
    void use() { std::cout << "Resource used" << std::endl; }
};

class ResourceManager {
private:
    std::unique_ptr<Resource> resource;

public:
    ResourceManager() : resource(std::make_unique<Resource>()) {}

    // Copy constructor
    ResourceManager(const ResourceManager& other) : resource(other.resource ? std::make_unique<Resource>() : nullptr) {
        std::cout << "ResourceManager copied" << std::endl;
    }

    void useResource() {
        if (resource) {
            resource->use();
        }
    }
};

int main() {
    ResourceManager rm1;
    ResourceManager rm2 = rm1;  // Copy constructor called

    std::cout << "Using rm1's resource: ";
    rm1.useResource();
    std::cout << "Using rm2's resource: ";
    rm2.useResource();

    return 0;
}
